



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>如何使用mysql profiling功能分析单条查询语句</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">如何使用mysql profiling功能分析单条查询语句</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 20:07:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><!--?xml version="1.0" encoding="UTF-8"?-->Mysql从5.1版本开始引入show profile来剖析单条语句功能</p>
<p><strong>一、<!--?xml version="1.0" encoding="UTF-8"?--> 查看是否支持这个功能</strong></p>
<p>yes表示支持</p>
<div>
<pre class="prettyprint linenums">mysql&gt; show variables like 'have_profiling';<br />
+----------------+-------+<br />
| Variable_name  | Value |<br />
+----------------+-------+<br />
| have_profiling | YES   |<br />
+----------------+-------+<br />
1 row in set (0.01 sec)</pre>
</div>
<p>二、使用步骤</p>
<p><strong>1.在<!--?xml version="1.0" encoding="UTF-8"?--> sql命令行中输入：set profiling=1;来开启（当前会话关闭前，只需要执行一次）</strong></p>
<div>
<pre class="prettyprint linenums">mysql&gt; set profiling=1;<br />
Query OK, 0 rows affected, 1 warning (0.00 sec)</pre>
</div>
<p>2.然后在服务器上执行你的SQL语句，都会被测量其消耗的时间和其他一些查询执行状态变更相关的数据</p>
<div>
<pre class="prettyprint linenums">mysql&gt; select count(*) from he_store_discount;<br />
+----------+<br />
| count(*) |<br />
+----------+<br />
|        1 |<br />
+----------+<br />
1 row in set (0.00 sec)</pre>
</div>
<p>3.<!--?xml version="1.0" encoding="UTF-8"?--> 然后再执行：show prifiles;命令，所有的查询SQL都会被列出来</p>
<div>
<pre class="prettyprint linenums">mysql&gt; show profiles;<br />
+----------+------------+----------------------------------------+<br />
| Query_ID | Duration   | Query                                  |<br />
+----------+------------+----------------------------------------+<br />
|        1 | 0.00013000 | select count(*) from he_store_discount |<br />
|        2 | 0.00290900 | show databases                         |<br />
|        3 | 0.00016200 | SELECT DATABASE()                      |<br />
|        4 | 0.00052800 | show databases                         |<br />
|        5 | 0.00204500 | show tables                            |<br />
|        6 | 0.00027000 | select count(*) from he_store_discount |<br />
+----------+------------+----------------------------------------+<br />
6 rows in set, 1 warning (0.00 sec)</pre>
</div>
<p>4.然后再根据编号(即Query_ID)查询具体SQL的执行过程</p>
<div>
<pre class="prettyprint linenums">mysql&gt; show profile for query 1;<br />
+---------------+----------+<br />
| Status        | Duration |<br />
+---------------+----------+<br />
| starting      | 0.000091 |<br />
| freeing items | 0.000028 |<br />
| cleaning up   | 0.000011 |<br />
+---------------+----------+<br />
3 rows in set, 1 warning (0.01 sec)

mysql&gt; show profile for query 2;<br />
+----------------------+----------+<br />
| Status               | Duration |<br />
+----------------------+----------+<br />
| starting             | 0.000044 |<br />
| checking permissions | 0.000011 |<br />
| Opening tables       | 0.000039 |<br />
| init                 | 0.000013 |<br />
| System lock          | 0.000008 |<br />
| optimizing           | 0.000006 |<br />
| statistics           | 0.000012 |<br />
| preparing            | 0.000012 |<br />
| executing            | 0.002696 |<br />
| Sending data         | 0.000021 |<br />
| end                  | 0.000004 |<br />
| query end            | 0.000006 |<br />
| closing tables       | 0.000003 |<br />
| removing tmp table   | 0.000006 |<br />
| closing tables       | 0.000003 |<br />
| freeing items        | 0.000017 |<br />
| cleaning up          | 0.000008 |<br />
+----------------------+----------+<br />
17 rows in set, 1 warning (0.00 sec)

mysql&gt; show profile for query 3;<br />
+----------------------+----------+<br />
| Status               | Duration |<br />
+----------------------+----------+<br />
| starting             | 0.000046 |<br />
| checking permissions | 0.000009 |<br />
| Opening tables       | 0.000008 |<br />
| init                 | 0.000014 |<br />
| optimizing           | 0.000008 |<br />
| executing            | 0.000012 |<br />
| end                  | 0.000006 |<br />
| query end            | 0.000008 |<br />
| closing tables       | 0.000007 |<br />
| freeing items        | 0.000027 |<br />
| cleaning up          | 0.000017 |<br />
+----------------------+----------+<br />
11 rows in set, 1 warning (0.00 sec)</pre>
</div>
<p>5.当查到最耗时的线程状态时，可以进一步选择all或者cpu,block io,page faults等明细类型来查看mysql在每个线程状态中使用什么资源上耗费了过高的时间：</p>
<div>
<pre class="prettyprint linenums">mysql&gt; show profile all for query 1;<br />
+---------------+----------+----------+------------+-------------------+---------------------+--------------+---------------+---------------+-------------------+-------------------+-------------------+-------+------------------+--------------+-------------+<br />
| Status        | Duration | CPU_user | CPU_system | Context_voluntary | Context_involuntary | Block_ops_in | Block_ops_out | Messages_sent | Messages_received | Page_faults_major | Page_faults_minor | Swaps | Source_function  | Source_file  | Source_line |<br />
+---------------+----------+----------+------------+-------------------+---------------------+--------------+---------------+---------------+-------------------+-------------------+-------------------+-------+------------------+--------------+-------------+<br />
| starting      | 0.000091 | 0.000073 |   0.000012 |                 0 |                   1 |            0 |             0 |             0 |                 0 |                 0 |                 0 |     0 | NULL             | NULL         |        NULL |<br />
| freeing items | 0.000028 | 0.000016 |   0.000011 |                 0 |                   0 |            0 |             0 |             1 |                 0 |                 0 |                 0 |     0 | mysql_parse      | sql_parse.cc |        5593 |<br />
| cleaning up   | 0.000011 | 0.000008 |   0.000003 |                 0 |                   0 |            0 |             0 |             0 |                 0 |                 0 |                 0 |     0 | dispatch_command | sql_parse.cc |        1902 |<br />
+---------------+----------+----------+------------+-------------------+---------------------+--------------+---------------+---------------+-------------------+-------------------+-------------------+-------+------------------+--------------+-------------+<br />
3 rows in set, 1 warning (0.00 sec)

mysql&gt; show profile cpu for query 1;<br />
+---------------+----------+----------+------------+<br />
| Status        | Duration | CPU_user | CPU_system |<br />
+---------------+----------+----------+------------+<br />
| starting      | 0.000091 | 0.000073 |   0.000012 |<br />
| freeing items | 0.000028 | 0.000016 |   0.000011 |<br />
| cleaning up   | 0.000011 | 0.000008 |   0.000003 |<br />
+---------------+----------+----------+------------+<br />
3 rows in set, 1 warning (0.00 sec)

mysql&gt; show profile block io for query 1;<br />
+---------------+----------+--------------+---------------+<br />
| Status        | Duration | Block_ops_in | Block_ops_out |<br />
+---------------+----------+--------------+---------------+<br />
| starting      | 0.000091 |            0 |             0 |<br />
| freeing items | 0.000028 |            0 |             0 |<br />
| cleaning up   | 0.000011 |            0 |             0 |<br />
+---------------+----------+--------------+---------------+<br />
3 rows in set, 1 warning (0.00 sec)

mysql&gt; show profile page faults for query 1;<br />
+---------------+----------+-------------------+-------------------+<br />
| Status        | Duration | Page_faults_major | Page_faults_minor |<br />
+---------------+----------+-------------------+-------------------+<br />
| starting      | 0.000091 |                 0 |                 0 |<br />
| freeing items | 0.000028 |                 0 |                 0 |<br />
| cleaning up   | 0.000011 |                 0 |                 0 |<br />
+---------------+----------+-------------------+-------------------+<br />
3 rows in set, 1 warning (0.00 sec)</pre>
</div>
<p><!--?xml version="1.0" encoding="UTF-8"?--> 上面的输出中可以以很高的精度显示了查询的响应时间，列出了查询执行的每个步骤花费的时间</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zer1x8.html">Cardinal：一个用于移动项目开发的轻量 CSS 框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwx1ok9.html">编译安装chkrootkit出现的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok1njp9.html">&num;linux包之psmisc之fuser命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1vy3n9.html">&lbrack;工作记录&rsqb; Android OpenSL ES&colon; references &amp;amp&semi; AAC related</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wmpw3q.html">PHP 打印调用函数入口地址（堆栈），方便调式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn4pwd8.html">linux管道的容量和内部组织方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd2zkr8.html">jquery 中ajax的参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gej6v48.html">MVC中验证码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkm3md8.html">用Laravel Sms实现 laravel短信验证码的发送</a>
		</li>
						<li><a href="https://www.batexi.com/a/950enge8.html">基于Vue2-Calendar改进的日历组件（含中文使用说明）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rwk628.html">python杂记一</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r21268.html">Codeforces Round &num;382 &lpar;Div&period; 2&rpar; C&period; Tennis Championship</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k143wq.html">TitanX Server安装Caffe</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kldp3q.html">vim  编辑  windows下的文本时出现乱码， 修改配置后     已解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppl1j79.html">【刷题】BZOJ 3238 &lbrack;Ahoi2013&rsqb;差异</a>
		</li>
						<li><a href="https://www.batexi.com/a/q15rzj09.html">Vue&period;js 使用注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77onmxq.html">我Java学习时的模样（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2xkxwl9.html">requireJS使用教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qloxejkq.html">1139&colon; &lbrack;POI2009&rsqb;Wie</a>
		</li>
						<li><a href="https://www.batexi.com/a/90d1l3o8.html">&lbrack;bzoj 1208&rsqb;STL水过</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnvzomk8.html">WebSocket、Socket</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j143149.html">Received empty response from Zabbix Agent at &lbrack;172&period;16&period;1&period;7&rsqb;&period;&period;&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pworx48.html">python --- 15    装饰器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r61358.html">linux内核中的dquot是什么&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gk4mzq.html">cf213E 线段树维护hash</a>
			</li>
						<li><a href="https://www.batexi.com/a/960wxej9.html">【做题】agc006C - Rabbit Exercise&mdash;&mdash;模型转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gexjzq.html">js作用域题目</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyz1zx9.html">SAP本地化-银企直连</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r7k0z8.html">Spring依赖</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyzy1d9.html">细菌多位点序列分型&lpar;Multilocus sequence typing，MLST&rpar;的原理及分型方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
